Debian Bug report logs - #630167
[cmake] Failing find_library on some (multiarch?) build machines

version graph

Package: cmake; Maintainer for cmake is Modestas Vainius <modax@debian.org>; Source for cmake is src:cmake.

Reported by: Sven Eckelmann <sven@narfation.org>

Date: Sat, 11 Jun 2011 18:45:01 UTC

Severity: normal

Found in version cmake/2.8.4+dfsg.1-4

Fixed in version cmake/2.8.4+dfsg.1-5

Done: Modestas Vainius <modax@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Modestas Vainius <modax@debian.org>:
Bug#630167; Package cmake. (Sat, 11 Jun 2011 18:45:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven Eckelmann <sven@narfation.org>:
New Bug report received and forwarded. Copy sent to Modestas Vainius <modax@debian.org>. (Sat, 11 Jun 2011 18:45:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Sven Eckelmann <sven@narfation.org>
To: submit@bugs.debian.org
Subject: [cmake] Failing find_library on some (multiarch?) build machines
Date: Sat, 11 Jun 2011 20:32:37 +0200
[Message part 1 (text/plain, inline)]
Package: cmake
Version: 2.8.4+dfsg.1-4
Severity: normal
User: multiarch-devel@lists.alioth.debian.org
Usertags: multiarch

I tried to do a multiarch upload of s3d and got build failures due to a 
problem in find_library on armel, kfreebsd-amd64 and kfreebsd-i386. Untested 
are hurd-i386, ia64, mipsel and sparc.

Just to give an example using kfreebsd-i386. The correct path to the multiarch 
libs in /usr is /usr/lib/i386-kfreebsd-gnu/. Now cmake only searches 
(according to CMAKE_C_LIBRARY_ARCHITECTURE which is "" in 
./CMakeFiles/CMakeCCompiler.cmake) in /usr/lib//. I haven't looked in the 
cmake internals to find the reason for that, but maybe the output of `gcc -v` 
helps (look at the i486 after "Target"):

Using built-in specs.
COLLECT_GCC=gcc
COLLECT_LTO_WRAPPER=/usr/lib/i386-kfreebsd-gnu/gcc/i486-kfreebsd-
gnu/4.6.1/lto-wrapper
Target: i486-kfreebsd-gnu
Configured with: ../src/configure -v --with-pkgversion='Debian 4.6.0-12' --
with-bugurl=file:///usr/share/doc/gcc-4.6/README.Bugs --enable-
languages=c,c++,fortran,objc,obj-c++ --prefix=/usr --program-suffix=-4.6 --
enable-shared --enable-multiarch --with-multiarch-defaults=i386-kfreebsd-gnu 
--enable-linker-build-id --with-system-zlib --libexecdir=/usr/lib/i386-
kfreebsd-gnu --without-included-gettext --enable-threads=posix --with-gxx-
include-dir=/usr/include/c++/4.6 --libdir=/usr/lib/i386-kfreebsd-gnu --enable-
nls --enable-clocale=gnu --enable-libstdcxx-debug --enable-libstdcxx-time=yes 
--enable-plugin --enable-objc-gc --with-arch-32=i586 --with-tune=generic --
enable-checking=release --build=i486-kfreebsd-gnu --host=i486-kfreebsd-gnu --
target=i486-kfreebsd-gnu
Thread model: posix
gcc version 4.6.1 20110608 (prerelease) (Debian 4.6.0-12) 
[signature.asc (application/pgp-signature, inline)]

Reply sent to Modestas Vainius <modax@debian.org>:
You have taken responsibility. (Sat, 11 Jun 2011 20:51:11 GMT) Full text and rfc822 format available.

Notification sent to Sven Eckelmann <sven@narfation.org>:
Bug acknowledged by developer. (Sat, 11 Jun 2011 20:51:11 GMT) Full text and rfc822 format available.

Message #10 received at 630167-close@bugs.debian.org (full text, mbox):

From: Modestas Vainius <modax@debian.org>
To: 630167-close@bugs.debian.org
Subject: Bug#630167: fixed in cmake 2.8.4+dfsg.1-5
Date: Sat, 11 Jun 2011 20:47:50 +0000
Source: cmake
Source-Version: 2.8.4+dfsg.1-5

We believe that the bug you reported is fixed in the latest version of
cmake, which is due to be installed in the Debian FTP archive:

cmake-curses-gui_2.8.4+dfsg.1-5_amd64.deb
  to main/c/cmake/cmake-curses-gui_2.8.4+dfsg.1-5_amd64.deb
cmake-data_2.8.4+dfsg.1-5_all.deb
  to main/c/cmake/cmake-data_2.8.4+dfsg.1-5_all.deb
cmake-dbg_2.8.4+dfsg.1-5_amd64.deb
  to main/c/cmake/cmake-dbg_2.8.4+dfsg.1-5_amd64.deb
cmake-doc_2.8.4+dfsg.1-5_all.deb
  to main/c/cmake/cmake-doc_2.8.4+dfsg.1-5_all.deb
cmake-qt-gui_2.8.4+dfsg.1-5_amd64.deb
  to main/c/cmake/cmake-qt-gui_2.8.4+dfsg.1-5_amd64.deb
cmake_2.8.4+dfsg.1-5.debian.tar.gz
  to main/c/cmake/cmake_2.8.4+dfsg.1-5.debian.tar.gz
cmake_2.8.4+dfsg.1-5.dsc
  to main/c/cmake/cmake_2.8.4+dfsg.1-5.dsc
cmake_2.8.4+dfsg.1-5_amd64.deb
  to main/c/cmake/cmake_2.8.4+dfsg.1-5_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 630167@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Modestas Vainius <modax@debian.org> (supplier of updated cmake package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 11 Jun 2011 22:47:18 +0300
Source: cmake
Binary: cmake cmake-data cmake-curses-gui cmake-qt-gui cmake-doc cmake-dbg
Architecture: source amd64 all
Version: 2.8.4+dfsg.1-5
Distribution: unstable
Urgency: medium
Maintainer: Modestas Vainius <modax@debian.org>
Changed-By: Modestas Vainius <modax@debian.org>
Description: 
 cmake      - cross-platform, open-source make system
 cmake-curses-gui - curses based user interface for CMake (ccmake)
 cmake-data - CMake data files (modules, templates and documentation)
 cmake-dbg  - debugging symbols for CMake
 cmake-doc  - extended documentation in various formats for CMake
 cmake-qt-gui - Qt4 based user interface for CMake (cmake-gui)
Closes: 630167
Changes: 
 cmake (2.8.4+dfsg.1-5) unstable; urgency=medium
 .
   * Fix multiarch regex to support armel and (hopefully) all other possible
     linux architectures (patch multiarch_basic_support.diff updated).
   * Support multiarch paths on kfreebsd and hurd (patch
     multiarch_basic_support.diff updated). (Closes: #630167)
   * Urgency=medium, the bugs above make cmake almost unusable on armel and
     kfreebsd.
Checksums-Sha1: 
 5363fb36dfabd7c70a3a985d6c99309d49b2753d 1511 cmake_2.8.4+dfsg.1-5.dsc
 6dadd5cd27a2993b6a0ea7578b7cb1f5769e5782 30226 cmake_2.8.4+dfsg.1-5.debian.tar.gz
 d30096f85a3035594e9296cc3559e34b0693bd9b 4147844 cmake_2.8.4+dfsg.1-5_amd64.deb
 e3c97f2dfaa8d2c64926230b8e492c15e6d1c22d 1255712 cmake-data_2.8.4+dfsg.1-5_all.deb
 6e5e63555e108ce058c1384f8d000cb4392c3f0f 1226900 cmake-curses-gui_2.8.4+dfsg.1-5_amd64.deb
 a751b7feb234285d35dd47fb100f777d843c4a98 1303446 cmake-qt-gui_2.8.4+dfsg.1-5_amd64.deb
 fa5fc6e1abb055e7f58c991c5465dea2f2226d52 1386694 cmake-doc_2.8.4+dfsg.1-5_all.deb
 c7a6f14852c1f87d31848630e3063985d1a8585a 59605290 cmake-dbg_2.8.4+dfsg.1-5_amd64.deb
Checksums-Sha256: 
 b580302105858c235730a062147ae88752e38a79c5f0fa9814cb6d88c8f8a557 1511 cmake_2.8.4+dfsg.1-5.dsc
 ca5d79b28d5d37b5f01cd7961630c7a8ed75856bb4d9d134e453838bf6c5e9e5 30226 cmake_2.8.4+dfsg.1-5.debian.tar.gz
 7f95c3d25c181bd106ae31105042922cbf307529e32f895f18f34057d4c255c7 4147844 cmake_2.8.4+dfsg.1-5_amd64.deb
 9c0c1cdfdabb8c3f7627ee82fc16fc4e03b437b75f32bfc85b3d919e87f2c9a8 1255712 cmake-data_2.8.4+dfsg.1-5_all.deb
 59a83545b558c50ac20b479142d090e70c3521f434b6b9e5ef4c097371d234a2 1226900 cmake-curses-gui_2.8.4+dfsg.1-5_amd64.deb
 0406b41b3a312a26c5fb583bac4b10eba907dcfe37771b44211ec8357a839d60 1303446 cmake-qt-gui_2.8.4+dfsg.1-5_amd64.deb
 8ffe2a191919b25147761bf6c43f13666a767709d7755a54ebe9315ffd00af39 1386694 cmake-doc_2.8.4+dfsg.1-5_all.deb
 5d1be991486fcbd597c9c2019ddc5cf98eae6f5dff5db4ebbddb38fefa1354df 59605290 cmake-dbg_2.8.4+dfsg.1-5_amd64.deb
Files: 
 dc24a5c21d6b2952ebc9ae4dde34e82a 1511 devel optional cmake_2.8.4+dfsg.1-5.dsc
 151193297c5dbc6bcfaf09a294d5b9b7 30226 devel optional cmake_2.8.4+dfsg.1-5.debian.tar.gz
 e8acd7c6d98089db5dc45872820da8d8 4147844 devel optional cmake_2.8.4+dfsg.1-5_amd64.deb
 5b2721ecd313caeef54bcfe3fa8551de 1255712 devel optional cmake-data_2.8.4+dfsg.1-5_all.deb
 3d2a6a7f9c0f8dd967c9851e86a47fb9 1226900 devel optional cmake-curses-gui_2.8.4+dfsg.1-5_amd64.deb
 708c417bc9d0885b8c40c9c7dd3a3b48 1303446 devel optional cmake-qt-gui_2.8.4+dfsg.1-5_amd64.deb
 30cb6735e8d90aa59606145150c92f62 1386694 doc optional cmake-doc_2.8.4+dfsg.1-5_all.deb
 4d3beced188107465b1ddec6d56362ba 59605290 debug extra cmake-dbg_2.8.4+dfsg.1-5_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEARECAAYFAk3z0LwACgkQHO9JRnPq4hRIxACeOnKlj5ImtRGakLzbmaV/9bEZ
UG4An0Ulba+JdTmC8RG1GURrckNW0TU5
=kqOb
-----END PGP SIGNATURE-----





Bug No longer marked as fixed in versions cmake/2.8.4+dfsg.1-5 and reopened. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 21 Jun 2011 11:18:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Modestas Vainius <modax@debian.org>:
Bug#630167; Package cmake. (Thu, 23 Jun 2011 11:24:26 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Tille <andreas@an3as.eu>:
Extra info received and forwarded to list. Copy sent to Modestas Vainius <modax@debian.org>. (Thu, 23 Jun 2011 11:24:31 GMT) Full text and rfc822 format available.

Message #17 received at 630167@bugs.debian.org (full text, mbox):

From: Andreas Tille <andreas@an3as.eu>
To: Debian Mentors List <debian-mentors@lists.debian.org>
Cc: 629815@bugs.debian.org, Debian Med Project List <debian-med@lists.debian.org>, 630167@bugs.debian.org
Subject: Re: Bug#629815: No rule to make target `/usr/lib/libdl.so'
Date: Thu, 23 Jun 2011 13:20:59 +0200
Hi again,

to give an update to this problem:

On Fri, Jun 10, 2011 at 11:37:00AM +0200, Mathieu Malaterre wrote:
> On Thu, Jun 9, 2011 at 11:27 PM, Andreas Tille <andreas@an3as.eu> wrote:
> > On Thu, Jun 09, 2011 at 01:02:56PM +0200, Sven Joachim wrote:
> >> >> The problem is that libdl.so has been moved to the multiarch paths in
> >> >> libc6-dev 2.13-5.  You must upgrade cmake to 2.8.4+dfsg.1-3, have you
> >> >> done that already?
> >> >
> >> > I'm building an unstable pbuilder chroot.  It is using the cmake
> >> > version you are mentioning:
> >> >
> >> > $ grep cmake.2\.8 ginkgocadx_2.4.1.1-1_amd64.build
> >> > Unpacking cmake (from .../cmake_2.8.4+dfsg.1-3_amd64.deb) ...
> >>
> >> Might be worth retrying with cmake 2.8.4+dfsg.1-4, currently in
> >> incoming.  It has a different multiarch implementation.
> >
> > $ grep cmake.2\.8 ginkgocadx_2.4.1.1-1_amd64.build
> > Unpacking cmake (from .../cmake_2.8.4+dfsg.1-4_amd64.deb) ...
> > I: new cache content cmake_2.8.4+dfsg.1-4_amd64.deb added
> >
> > No change. :-((
> >
> > Any further hint?
> 
> I think the issue is being worked on at the moment upstream:
> 
> http://public.kitware.com/Bug/view.php?id=12037#c26801
> 
> ...
> Modestas Vainius wrote:
> 2) Will those patches be part of 2.8.5? I want to emphasize that
> released Ubuntu 11.04 (natty) already has this multiarch enabled so
> upstream cmake up to and including 2.8.4 is basically unusable on
> those systems. That's because libc6 package is multiarch enabled and
> e.g. vanilla cmake 2.8.4 is not even able to set CMAKE_DL_LIBS
> properly.
> ...
> 
> IMHO cmake (current git master) does not handle this new libc6 layout
> for multiarch support

I tried to rebuild gofigure2 (which is affected by #629815) now I do
not get the 

   No rule to make target `/usr/lib/libdl.so', needed by `lib/libvtkRenderingAddOn2.so.0.8'

any more but rather

   No rule to make target `/usr/lib/libXt.so', needed by `lib/libPoissonReconstruction.so.0.8'

and thus I assume my action to reopen #630167 (which is unfortunately
not properly documented in the bug log) was not the right thing to do.
It rather seems that certain library packages need to be adapted to
the multiarch build and libc6-dev *now* works together with cmake but
libxt-dev does not.

Similarly I can confirm that when trying to build ginkgocadx I do not
run any more in the missing libdl.so but rather into

   No rule to make target `/lib/libwrap.so.0', needed by `src/cadxcore/libCADxCore.so.2.4.1.1'

which somehow smells like libwrap0 is guilty for the problem.  I admit
that this multiarch stuff is above my horizon and I hope that somebody
might be able to clarify what might be the correct way of action now.
 
Kind regards

      Andreas.

-- 
http://fam-tille.de




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#630167; Package cmake. (Thu, 23 Jun 2011 21:45:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Modestas Vainius <modax@debian.org>:
Extra info received and forwarded to list. (Thu, 23 Jun 2011 21:45:05 GMT) Full text and rfc822 format available.

Message #22 received at 630167@bugs.debian.org (full text, mbox):

From: Modestas Vainius <modax@debian.org>
To: Andreas Tille <andreas@an3as.eu>, 630167@bugs.debian.org
Cc: Debian Mentors List <debian-mentors@lists.debian.org>, 629815@bugs.debian.org, Debian Med Project List <debian-med@lists.debian.org>
Subject: Re: Bug#630167: Bug#629815: No rule to make target `/usr/lib/libdl.so'
Date: Fri, 24 Jun 2011 00:42:17 +0300
[Message part 1 (text/plain, inline)]
close 630167 2.8.4+dfsg.1-5
thanks

Hello,

On ketvirtadienis 23 Birželis 2011 14:20:59 Andreas Tille wrote:

> I tried to rebuild gofigure2 (which is affected by #629815) now I do
> not get the
> 
>    No rule to make target `/usr/lib/libdl.so', needed by
> `lib/libvtkRenderingAddOn2.so.0.8'
> 
> any more but rather
> 
>    No rule to make target `/usr/lib/libXt.so', needed by
> `lib/libPoissonReconstruction.so.0.8'

$ grep -rn -e '/usr/lib/libXt.so' /usr/lib/vtk-5.6/
/usr/lib/vtk-5.6/VTKLibraryDepends.cmake:76:  SET("vtkRendering_LIB_DEPENDS" 
"general;vtkGraphics;general;vtkImaging;general;vtkIO;general;vtkftgl;general;QtGui;general;QtCore;general;/usr/lib/libgl2ps.so;general;/usr/lib/libz.so;general;/usr/lib/libpng.so;general;/usr/lib/libz.so;general;/usr/lib/libGL.so;general;/usr/lib/libXt.so;general;X11;")
/usr/lib/vtk-5.6/VTKLibraryDepends.cmake:186:  SET("vtkRendering_LIB_DEPENDS" 
"vtkGraphics;vtkImaging;vtkIO;vtkftgl;QtGui;QtCore;/usr/lib/libgl2ps.so;/usr/lib/libz.so;/usr/lib/libpng.so;/usr/lib/libz.so;/usr/lib/libGL.so;/usr/lib/libXt.so;X11;")

$ grep -rn -e '/usr/lib/libdl.so' /usr/lib/vtk-5.6/
/usr/lib/vtk-5.6/VTKLibraryDepends.cmake:5:  SET("Cosmo_LIB_DEPENDS" 
"general;vtksys;general;vtkCommon;general;/usr/lib/openmpi/lib/libmpi_cxx.so;general;/usr/lib/openmpi/lib/libmpi.so;general;/usr/lib/openmpi/lib/libopen-
rte.so;general;/usr/lib/openmpi/lib/libopen-
pal.so;general;/usr/lib/libdl.so;general;/usr/lib/libnsl.so;general;/usr/lib/libutil.so;general;/usr/lib/libm.so;general;/usr/lib/libdl.so;")
/usr/lib/vtk-5.6/VTKLibraryDepends.cmake:6:  SET("MapReduceMPI_LIB_DEPENDS" 
"general;/usr/lib/openmpi/lib/libmpi_cxx.so;general;/usr/lib/openmpi/lib/libmpi.so;general;/usr/lib/openmpi/lib/libopen-
rte.so;general;/usr/lib/openmpi/lib/libopen-
pal.so;general;/usr/lib/libdl.so;general;/usr/lib/libnsl.so;general;/usr/lib/libutil.so;general;/usr/lib/libm.so;general;/usr/lib/libdl.so;")
/usr/lib/vtk-5.6/VTKLibraryDepends.cmake:9:  SET("VPIC_LIB_DEPENDS" 
"general;vtksys;general;/usr/lib/openmpi/lib/libmpi_cxx.so;general;/usr/lib/openmpi/lib/libmpi.so;general;/usr/lib/openmpi/lib/libopen-
rte.so;general;/usr/lib/openmpi/lib/libopen-
pal.so;general;/usr/lib/libdl.so;general;/usr/lib/libnsl.so;general;/usr/lib/libutil.so;general;/usr/lib/libm.so;general;/usr/lib/libdl.so;")
/usr/lib/vtk-5.6/VTKLibraryDepends.cmake:115:  SET("Cosmo_LIB_DEPENDS" 
"vtksys;vtkCommon;/usr/lib/openmpi/lib/libmpi_cxx.so;/usr/lib/openmpi/lib/libmpi.so;/usr/lib/openmpi/lib/libopen-
rte.so;/usr/lib/openmpi/lib/libopen-
pal.so;/usr/lib/libdl.so;/usr/lib/libnsl.so;/usr/lib/libutil.so;/usr/lib/libm.so;/usr/lib/libdl.so;")
/usr/lib/vtk-5.6/VTKLibraryDepends.cmake:116:  SET("MapReduceMPI_LIB_DEPENDS" 
"/usr/lib/openmpi/lib/libmpi_cxx.so;/usr/lib/openmpi/lib/libmpi.so;/usr/lib/openmpi/lib/libopen-
rte.so;/usr/lib/openmpi/lib/libopen-
pal.so;/usr/lib/libdl.so;/usr/lib/libnsl.so;/usr/lib/libutil.so;/usr/lib/libm.so;/usr/lib/libdl.so;")
/usr/lib/vtk-5.6/VTKLibraryDepends.cmake:119:  SET("VPIC_LIB_DEPENDS" 
"vtksys;/usr/lib/openmpi/lib/libmpi_cxx.so;/usr/lib/openmpi/lib/libmpi.so;/usr/lib/openmpi/lib/libopen-
rte.so;/usr/lib/openmpi/lib/libopen-
pal.so;/usr/lib/libdl.so;/usr/lib/libnsl.so;/usr/lib/libutil.so;/usr/lib/libm.so;/usr/lib/libdl.so;")

$ dpkg -S VTKLibraryDepends.cmake
libvtk5-dev: /usr/lib/vtk-5.6/VTKLibraryDepends.cmake

$ dpkg -l libvtk5-dev | grep ii
ii  libvtk5-dev    5.6.1-6     VTK header files for building C++ code

So you can reassign your bug where it belongs (libvtk5-dev). Unfortunately, VTK
has one of the most hackish (and outdated in places) cmake code. Good luck
fixing it.

> and thus I assume my action to reopen #630167 (which is unfortunately
> not properly documented in the bug log) was not the right thing to do.

Yes, it was not the right thing to do because:

1) the bug is not related to your problem. It was about kfreebsd and armel
while your package fails on all arches.
2) I had no clue what happened because original explanation didn't say
much at all. I have no idea how you managed to reopen it in such a cryptic
way.

> Similarly I can confirm that when trying to build ginkgocadx I do not
> run any more in the missing libdl.so but rather into
> 
>    No rule to make target `/lib/libwrap.so.0', needed by
> `src/cadxcore/libCADxCore.so.2.4.1.1'
> 
> which somehow smells like libwrap0 is guilty for the problem.  I admit
> that this multiarch stuff is above my horizon and I hope that somebody
> might be able to clarify what might be the correct way of action now.

Always grep the source before blaming something else :-)

$ grep -rn '/lib/libwrap.so.0' .
./src/cadxcore/CMakeLists.txt:171:      TARGET_LINK_LIBRARIES(${PROJECT_NAME} dcmdsig oflog 
/lib/libwrap.so.0)

-- 
Modestas Vainius <modax@debian.org>
[signature.asc (application/pgp-signature, inline)]

Bug marked as fixed in version 2.8.4+dfsg.1-5, send any further explanations to Sven Eckelmann <sven@narfation.org> Request was from Modestas Vainius <modax@debian.org> to control@bugs.debian.org. (Thu, 23 Jun 2011 21:45:07 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 22 Jul 2011 07:34:20 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 19:54:57 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.